module.exports = function(hljs) {

  var earthEngineKeywords = 
  '.Algorithms .FMask .fillMinima .matchClouds .GeometryConstructors .BBox .LineString .LinearRing .MultiGeometry .MultiLineString .MultiPoint .MultiPolygon .Point .Polygon .Rectangle ' +
  '.Image .Landsat .Segmentation .GMeans .KMeans .SNIC .seedGrid .TOA .calibratedRadiance .pathRowLimit .simpleCloudScore .simpleComposite .Sentinel2 .CDI ' +
  '.TemporalSegmentation .Ccdc .Ewmacd .LandTrendr .LandTrendrFit .StructuralChangeBreakpoints .VCT .Verdet .CannyEdgeDetector .Collection .CrossCorrelation .Date .Describe .Dictionary .Feature .HillShadow .HoughTransform .If .IsEqual .ObjectType .Proj .ProjectionTransform .String .Terrain '+
  '.Array .bitsToArray .cat .identity .abs .accum .acos .add .and .argmax .asin .atan .atan2 .bitCount .bitwiseAnd .bitwiseNot .bitwiseOr .bitwiseXor .byte .cbrt .ceil .cos .cosh .cut .digamma .divide .dotProduct .double .eigen .eq .erf .erfInv .erfc .erfcInv .exp .first .firstNonZero .float .floor .gamma .gammainc .get .gt .gte .hypot .int .int16 .int32 .int64 .int8 .lanczos .leftShift .length .log .log10 .long .lt .lte .mask .matrixCholeskyDecomposition .matrixDeterminant .matrixDiagonal .matrixFnorm .matrixInverse .matrixLUDecomposition .matrixMultiply .matrixPseudoInverse .matrixQRDecomposition .matrixSingularValueDecomposition .matrixSolve .matrixToDiag .matrixTrace .matrixTranspose .max .min .mod .multiply .neq .not .or .pad .pow .project .reduce .repeat .reshape .rightShift .round .short .signum .sin .sinh .slice .sort .sqrt .subtract .tan .tanh .toByte .toDouble .toFloat .toInt .toInt16 .toInt32 .toInt64 .toInt8 .toList .toLong .toShort .toUint16 .toUint32 .toUint8 .transpose .trigamma .uint16 .uint32 .uint8 ' +
  '.Blob .string .Classifier .url .confusionMatrix .explain .mode .schema .setOutputMode .train .amnhMaxent .decisionTree .decisionTreeEnsemble .libsvm .minimumDistance .smileCart .smileGradientTreeBoost .smileNaiveBayes .smileRandomForest .spectralRegion ' +
  '.Clusterer .wekaCascadeKMeans .wekaCobweb .wekaKMeans .wekaLVQ .wekaXMeans .schema .train ' +
  '.ConfusionMatrix .accuracy .array .consumersAccuracy .kappa .order .producersAccuracy ' +
  '.Date .fromYMD .parse .unitRatio .advance .aside .difference .evaluate .format .get .getFraction .getInfo .getRange .getRelative .millis .serialize .update ' +
  '.DateRange .unbounded .contains .end .intersection .intersects .isEmpty .isUnbounded .start .union '+
  '.Dictionary .fromLists .aside .combine .contains .evaluate .get .getArray .getGeometry .getInfo .getNumber .getString .keys .map .remove .rename .select .serialize .set .size .toArray .toImage .values ' +
  '.ErrorMargin .Feature .area .aside .bounds .buffer .centroid .containedIn .contains .convexHull .copyProperties .cutLines .difference .disjoint .dissolve .distance .evaluate .geometry .get .getArray .getInfo .getMap .getNumber .getString .hersDescriptor .id .intersection .intersects .length .perimeter .propertyNames .select .serialize .set .setGeometry .simplify .symmetricDifference .toArray .toDictionary .transform .union .withinDistance ' +
  '.FeatureCollection .randomPoints .aggregate_array .aggregate_count .aggregate_count_distinct .aggregate_first .aggregate_histogram .aggregate_max .aggregate_mean .aggregate_min .aggregate_product .aggregate_sample_sd .aggregate_sample_var .aggregate_stats .aggregate_sum .aggregate_total_sd .aggregate_total_var .aside .classify .cluster .copyProperties .distance .distinct .draw .errorMatrix .evaluate .filter .filterBounds .filterDate .filterMetadata .first .flatten .geometry .get .getArray .getDownloadURL .getInfo .getMap .getNumber .getString .inverseDistance .iterate .kriging .limit .makeArray .map .merge .propertyNames .randomColumn .reduceColumns .reduceToImage .remap .select .serialize .set .size .sort .style .toDictionary .toList .union ' +
  '.and .bounds .calendarRange .contains .date .dateRangeContains .dayOfYear .disjoint .eq .equals .expression .greaterThan .greaterThanOrEquals .gt .gte .hasType .inList .intersects .isContained .lessThan .lessThanOrEquals .listContains .lt .lte .maxDifference .metadata .neq .notEquals .notNull .or .rangeContains .stringContains .stringEndsWith .stringStartsWith .withinDistance .aside .evaluate .getInfo .not .serialize ' +
  '.area .aside .bounds .buffer .centroid .containedIn .contains .convexHull .coordinates .coveringGrid .cutLines .difference .disjoint .dissolve .distance .edgesAreGeodesics .evaluate .geodesic .geometries .getInfo .intersection .intersects .isUnbounded .length .perimeter .projection .serialize .simplify .symmetricDifference .toGeoJSON .toGeoJSONString .transform .type .union .withinDistance ' +
  '.BBox .LineString .LinearRing .MultiLineString .MultiPoint .MultiPolygon .Point .Polygon .Rectangle ' +
  '.cat .constant .load .loadGeoTIFF .matrixIdentity .pixelArea .pixelCoordinates .pixelLonLat .random .rgb .abs .acos .add .addBands .and .arrayAccum .arrayArgmax .arrayCat .arrayDimensions .arrayDotProduct .arrayFlatten .arrayGet .arrayLength .arrayLengths .arrayMask .arrayPad .arrayProject .arrayReduce .arrayRepeat .arrayReshape .arraySlice .arraySort .arrayTranspose .aside .asin .atan .atan2 .bandNames .bandTypes .bitCount .bitsToArrayImage .bitwiseAnd '+
  '.bitwiseNot .bitwiseOr .bitwiseXor .blend .byte .cast .cbrt .ceil .changeProj .clamp .classify .clip .clipToBoundsAndScale .clipToCollection .cluster .connectedComponents .connectedPixelCount .convolve .copyProperties .cos .cosh .cumulativeCost .date .derivative .digamma .directionalDistanceTransform .displace .displacement .distance .divide .double .entropy .eq .erf .erfInv .erfc .erfcInv .evaluate .exp .expression .fastDistanceTransform .first .firstNonZero .float .floor .focalMax .focalMean .focalMedian .focalMin .focalMode .gamma .gammainc .geometry .get .getArray .getDownloadURL .getInfo .getMap .getNumber .getString .getThumbId .getThumbURL .glcmTexture .gradient .gt .gte .hersDescriptor .hersFeature .hersImage .hsvToRgb .hypot .id .int .int16 .int32 .int64 .int8 .interpolate .lanczos .leftShift .log .log10 .long .lt .lte .mask .matrixCholeskyDecomposition .matrixDeterminant .matrixDiagonal .matrixFnorm .matrixInverse .matrixLUDecomposition .matrixMultiply .matrixPseudoInverse .matrixQRDecomposition .matrixSingularValueDecomposition .matrixSolve .matrixToDiag .matrixTrace .matrixTranspose .max .medialAxis .metadata .min .mod .multiply .neighborhoodToArray .neighborhoodToBands .neq .normalizedDifference .not .or .paint .polynomial .pow .projection .propertyNames .randomVisualizer .reduce .reduceConnectedComponents .reduceNeighborhood .reduceRegion .reduceRegions .reduceResolution .reduceToVectors .regexpRename .register .remap .rename .reproject .resample .rgbToHsv .rightShift .round .rsedTransform .sample .sampleRectangle .sampleRegions .select .selfMask .serialize .set .setDefaultProjection .short .signum .sin .sinh .sldStyle .slice .spectralDilation .spectralDistance .spectralErosion .spectralGradient .sqrt .stratifiedSample .subtract .tan .tanh .toArray .toByte .toDictionary .toDouble .toFloat .toInt .toInt16 .toInt32 .toInt64 .toInt8 .toLong .toShort .toUint16 .toUint32 .toUint8 .translate .trigamma .uint16 .uint32 .uint8 .unitScale .unmask .unmix .updateMask .visualize .where .zeroCrossing ' +
  '.Image .fromImages .load .aggregate_array .aggregate_count .aggregate_count_distinct .aggregate_first .aggregate_histogram .aggregate_max .aggregate_mean .aggregate_min .aggregate_product .aggregate_sample_sd .aggregate_sample_var .aggregate_stats .aggregate_sum .aggregate_total_sd .aggregate_total_var .and .aside .cast .combine .copyProperties .count .distance .distinct .draw .errorMatrix .evaluate .filter .filterBounds .filterDate .filterMetadata .first .flatten .formaTrend .geometry .get .getArray .getFilmstripThumbURL .getInfo .getMap .getNumber .getRegion .getString .getVideoThumbURL .iterate .limit .map .max .mean .median .merge .min .mode .mosaic .or .product .propertyNames .qualityMosaic .randomColumn .reduce .reduceColumns .reduceToImage .remap .select .serialize .set .size .sort .style .sum .toArray .toArrayPerBand .toBands .toDictionary .toList .union ' +
  '.Join .inner .inverted .saveAll .saveBest .saveFirst .simple .apply' +
  '.Kernel .chebyshev .circle .compass .cross .diamond .euclidean .fixed .gaussian .kirsch .laplacian4 .laplacian8 .manhattan .octagon .plus .prewitt .rectangle .roberts .sobel .square .add .inverse .rotate ' +
  '.add .aside .cat .contains .containsAll .distinct .equals .evaluate .filter .flatten .frequency .get .getArray .getGeometry .getInfo .getNumber .getString .indexOf .indexOfSublist .insert .iterate .join .lastIndexOfSubList .length .map .reduce .remove .removeAll .replace .replaceAll .reverse .rotate .serialize .set .shuffle .size .slice .sort .splice .swap .unzip .zip .List .repeat .sequence ' +
  '.Model .fromAiPlatformPredictor .predictImage .predictProperties '+
  '.Number .parse .expression .abs .acos .add .and .aside .asin .atan .atan2 .bitCount .bitwiseAnd .bitwiseNot .bitwiseOr .bitwiseXor .byte .cbrt .ceil .clamp .cos .cosh .digamma .divide .double .eq .erf .erfInv .erfc .erfcInv .evaluate .exp .first .firstNonZero .float .floor .format .gamma .gammainc .getInfo .gt .gte .hypot .int .int16 .int32 .int64 .int8 .lanczos .leftShift .log .log10 .long .lt .lte .max .min .mod .multiply .neq .not .or .pow .rightShift .round .serialize .short .signum .sin .sinh .sqrt .subtract .tan .tanh .toByte .toDouble .toFloat .toInt .toInt16 .toInt32 .toInt64 .toInt8 .toLong .toShort .toUint16 .toUint32 .toUint8 .trigamma .uint16 .uint32 .uint8 .unitScale '+
  '.PixelType .double .float .int16 .int32 .int64 .int8 .uint16 .uint32 .uint8 .dimensions .maxValue .minValue .precision'+
  '.Projection .atScale .crs .nominalScale .scale .transform .translate .wkt ' +
  '.Reducer .allNonZero .and .anyNonZero .autoHistogram .bitwiseAnd .bitwiseOr .centeredCovariance .circularMean .circularStddev .circularVariance .count .countDistinct .countDistinctNonNull .countEvery .countRuns .covariance .first .firstNonNull .fixed2DHistogram .fixedHistogram .frequencyHistogram .geometricMedian .histogram .intervalMean .kendallsCorrelation .kurtosis .last .lastNonNull .linearFit .linearRegression .max .mean .median .min .minMax .mode .or .pearsonsCorrelation .percentile .product .ridgeRegression .robustLinearRegression .sampleStdDev .sampleVariance .sensSlope .skew .spearmansCorrelation .stdDev .sum .toCollection .toList .variance '+
  '.combine .disaggregate .forEach .forEachBand .forEachElement .getOutputs .group .repeat .setOutputs .splitWeights .unweighted '+
  '.String .encodeJSON .aside .cat .compareTo .decodeJSON .equals .evaluate .getInfo .index .length .match .replace .rindex .serialize .slice .split .toLowerCase .toUpperCase .trim ' +
  '.Terrain .aspect .fillMinima .hillShadow .hillshade .products .slope ' +
  '.data .authenticate .authenticateViaOauth .authenticateViaPopup .authenticateViaPrivateKey .cancelOperation .cancelTask .computeValue .copyAsset .createAsset .createAssetHome .createFolder .deleteAsset .getAsset .getAssetAcl .getAssetRootQuota .getAssetRoots .getDownloadId .getFilmstripThumbId .getInfo .getList .getMapId .getOperation .getTableDownloadId .getTaskList .getTaskListWithLimit .getTaskStatus .getThumbId .getTileUrl .getVideoThumbId .listAssets .listBuckets .listFeatures .listImages .listOperations .makeDownloadUrl .makeTableDownloadUrl .makeThumbUrl .newTaskId .renameAsset .setAssetAcl .setAssetProperties .startIngestion .startProcessing .startTableIngestion .updateAsset .updateTask ' +
  '.array .values .Chart .setChartType .setDataTable .setOptions .setSeriesNames .setView .transform ' +
  '.byFeature .byProperty .groups .histogram .byClass .byRegion .doySeries .doySeriesByRegion .doySeriesByYear .histogram .regions .series .seriesByRegion ' +
  '.add .addLayer .centerObject .clear .drawingTools .getBounds .getCenter .getScale .getZoom .layers .onChangeBounds .onChangeCenter .onChangeZoom .onClick .onIdle .onTileLoaded .remove .setCenter .setControlVisibility .setGestureHandling .setLocked .setOptions .setZoom .style .unlisten .widgets '



  var IDENT_RE = '[A-Za-z$_][0-9A-Za-z$_]*';
  var KEYWORDS = {
    keyword:
      'in of if for while finally var new function do return void else break catch ' +
      'instanceof with throw case default try this switch continue typeof delete ' +
      'let yield const export super debugger as async await static ' +
      // ECMAScript 6 modules import
      'import from as'
    ,
    literal:
      'true false null undefined NaN Infinity',
    built_in: 'ee Map'
  };
  var NUMBER = {
    className: 'number',
    variants: [
      { begin: '\\b(0[bB][01]+)n?' },
      { begin: '\\b(0[oO][0-7]+)n?' },
      { begin: hljs.C_NUMBER_RE + 'n?' }
    ],
    relevance: 0
  };
  var SUBST = {
    className: 'subst',
    begin: '\\$\\{', end: '\\}',
    keywords: KEYWORDS,
    contains: []  // defined later
  };
  var HTML_TEMPLATE = {
    begin: 'html`', end: '',
    starts: {
      end: '`', returnEnd: false,
      contains: [
        hljs.BACKSLASH_ESCAPE,
        SUBST
      ],
      subLanguage: 'xml',
    }
  };
  var CSS_TEMPLATE = {
    begin: 'css`', end: '',
    starts: {
      end: '`', returnEnd: false,
      contains: [
        hljs.BACKSLASH_ESCAPE,
        SUBST
      ],
      subLanguage: 'css',
    }
  };
  var TEMPLATE_STRING = {
    className: 'string',
    begin: '`', end: '`',
    contains: [
      hljs.BACKSLASH_ESCAPE,
      SUBST
    ]
  };
  SUBST.contains = [
    hljs.APOS_STRING_MODE,
    hljs.QUOTE_STRING_MODE,
    HTML_TEMPLATE,
    CSS_TEMPLATE,
    TEMPLATE_STRING,
    NUMBER,
    hljs.REGEXP_MODE
  ];
  var PARAMS_CONTAINS = SUBST.contains.concat([
    hljs.C_BLOCK_COMMENT_MODE,
    hljs.C_LINE_COMMENT_MODE
  ]);

  var EARTH_ENGINE = {
    begin: /[.]/, 
    end: /[.(]/,
    // lexemes: '.[a-z]+',
    keywords: earthEngineKeywords,
    className: "built_in"
  }

  return {
    aliases: ['js', 'jsx'],
    keywords: KEYWORDS,
    contains: [
      {
        className: 'meta',
        relevance: 10,
        begin: /^\s*['"]use (strict|asm)['"]/
      },
      {
        className: 'meta',
        begin: /^#!/, end: /$/
      },
      EARTH_ENGINE,
      hljs.APOS_STRING_MODE,
      hljs.QUOTE_STRING_MODE,
      HTML_TEMPLATE,
      CSS_TEMPLATE,
      TEMPLATE_STRING,
      hljs.C_LINE_COMMENT_MODE,
      hljs.C_BLOCK_COMMENT_MODE,
      NUMBER,
      { // object attr container
        begin: /[{,\n]\s*/, relevance: 0,
        contains: [
          {
            begin: IDENT_RE + '\\s*:', returnBegin: true,
            relevance: 0,
            contains: [{className: 'attr', begin: IDENT_RE, relevance: 0}]
          }
        ]
      },
      { // "value" container
        begin: '(' + hljs.RE_STARTERS_RE + '|\\b(case|return|throw)\\b)\\s*',
        keywords: 'return throw case',
        contains: [
          hljs.C_LINE_COMMENT_MODE,
          hljs.C_BLOCK_COMMENT_MODE,
          hljs.REGEXP_MODE,
          {
            className: 'function',
            begin: '(\\(.*?\\)|' + IDENT_RE + ')\\s*=>', returnBegin: true,
            end: '\\s*=>',
            contains: [
              {
                className: 'params',
                variants: [
                  {
                    begin: IDENT_RE
                  },
                  {
                    begin: /\(\s*\)/,
                  },
                  {
                    begin: /\(/, end: /\)/,
                    excludeBegin: true, excludeEnd: true,
                    keywords: KEYWORDS,
                    contains: PARAMS_CONTAINS
                  }
                ]
              }
            ]
          },
          {
            className: '',
            begin: /\s/,
            end: /\s*/,
            skip: true,
          },
          { // E4X / JSX
            begin: /</, end: /(\/[A-Za-z0-9\\._:-]+|[A-Za-z0-9\\._:-]+\/)>/,
            subLanguage: 'xml',
            contains: [
              { begin: /<[A-Za-z0-9\\._:-]+\s*\/>/, skip: true },
              {
                begin: /<[A-Za-z0-9\\._:-]+/, end: /(\/[A-Za-z0-9\\._:-]+|[A-Za-z0-9\\._:-]+\/)>/, skip: true,
                contains: [
                  { begin: /<[A-Za-z0-9\\._:-]+\s*\/>/, skip: true },
                  'self'
                ]
              }
            ]
          }
        ],
        relevance: 0
      },
      {
        className: 'function',
        beginKeywords: 'function', end: /\{/, excludeEnd: true,
        contains: [
          hljs.inherit(hljs.TITLE_MODE, {begin: IDENT_RE}),
          {
            className: 'params',
            begin: /\(/, end: /\)/,
            excludeBegin: true,
            excludeEnd: true,
            contains: PARAMS_CONTAINS
          }
        ],
        illegal: /\[|%/
      },
      {
        begin: /\$[(.]/ // relevance booster for a pattern common to JS libs: `$(something)` and `$.something`
      },
      hljs.METHOD_GUARD,
      { // ES6 class
        className: 'class',
        beginKeywords: 'class', end: /[{;=]/, excludeEnd: true,
        illegal: /[:"\[\]]/,
        contains: [
          {beginKeywords: 'extends'},
          hljs.UNDERSCORE_TITLE_MODE
        ]
      },
      {
        beginKeywords: 'constructor get set', end: /\{/, excludeEnd: true
      }
    ],
    illegal: /#(?!!)/
  };
};